// A Bison parser, made by GNU Bison 3.5.1.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
** \file ../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.hpp
** Define the cubeplparser::parser class.
*/

// C++ LALR(1) parser skeleton written by Akim Demaille.

// Undocumented macros, especially those whose name start with YY_,
// are private implementation details.  Do not rely on them.

#ifndef YY_CUBEPLPARSER_CUBELIB_BUILD_FRONTEND_SRC_CUBE_SRC_SYNTAX_CUBEPL_CUBEPL1PARSER_HPP_INCLUDED
# define YY_CUBEPLPARSER_CUBELIB_BUILD_FRONTEND_SRC_CUBE_SRC_SYNTAX_CUBEPL_CUBEPL1PARSER_HPP_INCLUDED
// "%code requires" blocks.
#line 17 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.yy"

/*** C/C++ Declarations ***/

#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <utility>
#include <string>
#include <vector>
#include <regex>

#include "CubeTypes.h"
#include "CubeSysres.h"
#include "CubeLocation.h"
#include "CubeLocationGroup.h"
#include "CubeSystemTreeNode.h"
#include "CubePL1ParseContext.h"

#include "CubeEncapsulation.h"
#include "CubeNegativeEvaluation.h"
#include "CubeConstantEvaluation.h"
#include "CubeStringConstantEvaluation.h"

#include "CubeDirectMetricEvaluation.h"
#include "CubePlusEvaluation.h"
#include "CubeMinusEvaluation.h"
#include "CubeMultEvaluation.h"
#include "CubeDivideEvaluation.h"
#include "CubePowerEvaluation.h"

#include "CubeAndEvaluation.h"
#include "CubeOrEvaluation.h"
#include "CubeXorEvaluation.h"
#include "CubeNotEvaluation.h"

#include "CubeStringEqualityEvaluation.h"
#include "CubeStringSemiEqualityEvaluation.h"
#include "CubeRegexEvaluation.h"
#include "CubeLowerCaseEvaluation.h"
#include "CubeUpperCaseEvaluation.h"
#include "CubeMetricGetEvaluation.h"
#include "CubeEnvEvaluation.h"


#include "CubeBiggerEvaluation.h"
#include "CubeSmallerEvaluation.h"
#include "CubeHalfBiggerEvaluation.h"
#include "CubeHalfSmallerEvaluation.h"
#include "CubeEqualEvaluation.h"
#include "CubeNotEqualEvaluation.h"

#include "CubeArgumentEvaluation.h"
#include "CubeATanEvaluation.h"
#include "CubeTanEvaluation.h"
#include "CubeACosEvaluation.h"
#include "CubeASinEvaluation.h"
#include "CubeCosEvaluation.h"
#include "CubeSinEvaluation.h"
#include "CubeAbsEvaluation.h"

#include "CubeLnEvaluation.h"
#include "CubeExpEvaluation.h"

#include "CubeRandomEvaluation.h"
#include "CubeSqrtEvaluation.h"

#include "CubeSgnEvaluation.h"
#include "CubePosEvaluation.h"
#include "CubeNegEvaluation.h"
#include "CubeFloorEvaluation.h"
#include "CubeCeilEvaluation.h"

#include "CubeMinEvaluation.h"
#include "CubeMaxEvaluation.h"

#include "CubeLambdaCalculEvaluation.h"
#include "CubeAssignmentEvaluation.h"
#include "CubeVariableEvaluation.h"
#include "CubeShortIfEvaluation.h"
#include "CubeFullIfEvaluation.h"
#include "CubeExtendedIfEvaluation.h"
#include "CubeWhileEvaluation.h"
#include "CubeMetricSetEvaluation.h"

#include "CubeSizeOfVariableEvaluation.h"
#include "CubeDefinedVariableEvaluation.h"
#include "CubePL1Driver.h"




#line 140 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.hpp"


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF( Type ) Type &&
# define YY_RVREF( Type )    Type &&
# define YY_COPY( Type )     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF( Type ) Type &
# define YY_RVREF( Type )    const Type &
# define YY_COPY( Type )     const Type &
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ( )
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif
# include "location.hh"


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + ( 96 <= __GNUC_MINOR__ )
#  define YY_ATTRIBUTE_PURE __attribute__ ( ( __pure__ ) )
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + ( 7 <= __GNUC_MINOR__ )
#  define YY_ATTRIBUTE_UNUSED __attribute__ ( ( __unused__ ) )
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if !defined lint || defined __GNUC__
# define YYUSE( E ) ( ( void )( E ) )
#else
# define YYUSE( E ) /* empty */
#endif

#if defined __GNUC__ && !defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma( "GCC diagnostic push" )                                     \
    _Pragma( "GCC diagnostic ignored \"-Wuninitialized\"" )              \
    _Pragma( "GCC diagnostic ignored \"-Wmaybe-uninitialized\"" )
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma( "GCC diagnostic pop" )
#else
# define YY_INITIAL_VALUE( Value ) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE( Value ) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && !defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma( "GCC diagnostic push" )                            \
    _Pragma( "GCC diagnostic ignored \"-Wuseless-cast\"" )
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma( "GCC diagnostic pop" )
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST( Type, Val ) static_cast<Type> ( Val )
#   define YY_REINTERPRET_CAST( Type, Val ) reinterpret_cast<Type> ( Val )
#  else
#   define YY_CAST( Type, Val ) ( ( Type )( Val ) )
#   define YY_REINTERPRET_CAST( Type, Val ) ( ( Type )( Val ) )
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ( ( void* )0 )
#  endif
# endif

/* Debug traces.  */
#ifndef CUBEPLPARSERDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define CUBEPLPARSERDEBUG 1
#  else
#   define CUBEPLPARSERDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define CUBEPLPARSERDEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined CUBEPLPARSERDEBUG */

namespace cubeplparser
{
#line 277 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.hpp"




/// A Bison parser.
class CubePL1Parser
{
public:
#ifndef CUBEPLPARSERSTYPE
    /// Symbol semantic values.
    union semantic_type
    {
#line 155 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.yy"

#line 292 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.hpp"
    };
#else
    typedef CUBEPLPARSERSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
        syntax_error ( const location_type& l, const std::string& m )
            : std::runtime_error( m )
            , location( l )
        {
        }

        syntax_error ( const syntax_error& s )
            : std::runtime_error( s.what() )
            , location( s.location )
        {
        }

        ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

        location_type location;
    };

    /// Tokens.
    struct token
    {
        enum yytokentype
        {
            END                            = 0,
            START_DOCUMENT                 = 602,
            END_DOCUMENT                   = 603,
            OP_PLUS                        = 604,
            OP_MINUS                       = 605,
            OP_MULT                        = 606,
            OP_DIVIDE                      = 607,
            OP_POWER                       = 608,
            OPEN_EXP                       = 609,
            CLOSE_EXP                      = 610,
            OPEN_ARRAY_INDEX               = 611,
            CLOSE_ARRAY_INDEX              = 612,
            OPEN_LCALC                     = 613,
            CLOSE_LCALC                    = 614,
            OPEN_GM_CUBEPL                 = 615,
            CLOSE_GM_CUBEPL                = 616,
            RETURN_EXP                     = 617,
            STATEMENT_SEP                  = 618,
            SIZEOF                         = 619,
            DEFINED                        = 620,
            LOCAL_VAR                      = 621,
            GLOBAL_VAR                     = 622,
            ABS_MARK                       = 623,
            ARGUMENT1                      = 624,
            ARGUMENT2                      = 625,
            FUN_SQRT                       = 626,
            FUN_SIN                        = 627,
            FUN_ASIN                       = 628,
            FUN_COS                        = 629,
            FUN_ACOS                       = 630,
            FUN_TAN                        = 631,
            FUN_ATAN                       = 632,
            FUN_EXP                        = 633,
            FUN_LOG                        = 634,
            FUN_ABS                        = 635,
            FUN_RANDOM                     = 636,
            FUN_SGN                        = 637,
            FUN_POS                        = 638,
            FUN_NEG                        = 639,
            FUN_FLOOR                      = 640,
            FUN_CEIL                       = 641,
            FUN_MIN                        = 642,
            FUN_MAX                        = 643,
            KEYWORD_IF                     = 644,
            KEYWORD_ELSEIF                 = 645,
            KEYWORD_ELSE                   = 646,
            KEYWORD_WHILE                  = 647,
            KEYWORD_ASSIGN                 = 648,
            KEYWORD_BIGGER                 = 649,
            KEYWORD_EQUAL                  = 650,
            KEYWORD_STRING_EQUAL           = 651,
            KEYWORD_STRING_SEMI_EQUAL      = 652,
            KEYWORD_HALFBIGGER             = 653,
            KEYWORD_HALFSMALLER            = 654,
            KEYWORD_NOT_EQUAL              = 655,
            KEYWORD_SMALLER                = 656,
            KEYWORD_NOT                    = 657,
            KEYWORD_AND                    = 658,
            KEYWORD_OR                     = 659,
            KEYWORD_XOR                    = 660,
            KEYWORD_TRUE                   = 661,
            KEYWORD_FALSE                  = 662,
            KEYWORD_VAR                    = 663,
            COMMA                          = 664,
            KEYWORD_REGEXP                 = 665,
            KEYWORD_METRIC                 = 666,
            KEYWORD_FIXED_METRIC           = 667,
            KEYWORD_METRIC_CALL            = 668,
            KEYWORD_ENV                    = 669,
            KEYWORD_LOWERCASE              = 670,
            KEYWORD_UPPERCASE              = 671,
            KEYWORD_GHOST_POSTMETRIC       = 672,
            KEYWORD_GHOST_PREMETRIC        = 673,
            KEYWORD_METRIC_INIT            = 674,
            KEYWORD_METRIC_FLEX_AGGR_PLUS  = 675,
            KEYWORD_METRIC_FLEX_AGGR_MINUS = 676,
            KEYWORD_METRIC_SET             = 677,
            KEYWORD_METRIC_GET             = 678,
            CONSTANT                       = 100,
            STRING_CONSTANT                = 200,
            STRING_TEXT                    = 210,
            METRIC_NAME                    = 300,
            INIT_METRIC_NAME               = 301,
            INCL_MODIFICATOR               = 679,
            EXCL_MODIFICATOR               = 680,
            SAME_MODIFICATOR               = 600,
            QUOTED_STRING                  = 400,
            REGEXP_STRING                  = 500,
            FUNC2                          = 681,
            SIGN                           = 682
        };
    };

    /// (External) token type, as returned by yylex.
    typedef token::yytokentype token_type;

    /// Symbol type: an internal symbol number.
    typedef int symbol_number_type;

    /// The symbol type number to denote an empty symbol.
    enum { empty_symbol = -2 };

    /// Internal symbol number for tokens (subsumed by symbol_number_type).
    typedef signed char token_number_type;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol type
    /// via type_get ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
        /// Alias to Base.
        typedef Base super_type;

        /// Default constructor.
        basic_symbol ()
            : value()
            , location()
        {
        }

#if 201103L <= YY_CPLUSPLUS
        /// Move constructor.
        basic_symbol ( basic_symbol&& that );
#endif

        /// Copy constructor.
        basic_symbol ( const basic_symbol& that );
        /// Constructor for valueless symbols.
        basic_symbol ( typename Base::kind_type     t,
                       YY_MOVE_REF ( location_type )l );

        /// Constructor for symbols with semantic value.
        basic_symbol ( typename Base::kind_type  t,
                       YY_RVREF ( semantic_type )v,
                       YY_RVREF ( location_type )l );

        /// Destroy the symbol.
        ~basic_symbol ()
        {
            clear();
        }

        /// Destroy contents, and record that is empty.
        void
        clear()
        {
            Base::clear();
        }

        /// Whether empty.
        bool
        empty() const YY_NOEXCEPT;

        /// Destructive move, \a s is emptied into this.
        void
        move( basic_symbol& s );

        /// The semantic value.
        semantic_type value;

        /// The location.
        location_type location;

private:
#if YY_CPLUSPLUS < 201103L
        /// Assignment operator.
        basic_symbol&
        operator=( const basic_symbol& that );

#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_type
    {
        /// Default constructor.
        by_type ();

#if 201103L <= YY_CPLUSPLUS
        /// Move constructor.
        by_type ( by_type&& that );
#endif

        /// Copy constructor.
        by_type ( const by_type& that );

        /// The symbol type as needed by the constructor.
        typedef token_type kind_type;

        /// Constructor from (external) token numbers.
        by_type ( kind_type t );

        /// Record that this symbol is empty.
        void
        clear();

        /// Steal the symbol type from \a that.
        void
        move( by_type& that );

        /// The (internal) type number (corresponding to \a type).
        /// \a empty when empty.
        symbol_number_type
        type_get() const YY_NOEXCEPT;

        /// The symbol type.
        /// \a empty_symbol when empty.
        /// An int, not token_number_type, to be able to store empty_symbol.
        int type;
    };

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_type>
    {};

    /// Build a parser object.
    CubePL1Parser ( class CubePL1ParseContext& parseContext_yyarg,
                        class CubePL1Scanner&  CubePL1Lexer_yyarg );
    virtual
    ~CubePL1Parser ();

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int
    operator()();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int
    parse();

#if CUBEPLPARSERDEBUG
    /// The current debugging stream.
    std::ostream&
    debug_stream() const YY_ATTRIBUTE_PURE;

    /// Set the current debugging stream.
    void
    set_debug_stream( std::ostream& );

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type
    debug_level() const YY_ATTRIBUTE_PURE;

    /// Set the current debugging level.
    void
    set_debug_level( debug_level_type l );

#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void
    error( const location_type& loc,
           const std::string&   msg );

    /// Report a syntax error.
    void
    error( const syntax_error& err );



private:
    /// This class is not copyable.
    CubePL1Parser ( const CubePL1Parser& );
    CubePL1Parser&
    operator=( const CubePL1Parser& );

    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// Generate an error message.
    /// \param yystate   the state where the error occurred.
    /// \param yyla      the lookahead token.
    virtual std::string
    yysyntax_error_( state_type         yystate,
                     const symbol_type& yyla ) const;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type
    yy_lr_goto_state_( state_type yystate,
                       int        yysym );

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool
    yy_pact_value_is_default_( int yyvalue );

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool
    yy_table_value_is_error_( int yyvalue );

    static const short       yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token number \a t to a symbol number.
    /// In theory \a t should be a token_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static token_number_type
    yytranslate_( int t );

    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const unsigned char yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const unsigned char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const unsigned char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string
    yytnamerr_( const char* n );


    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#if CUBEPLPARSERDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void
    yy_reduce_print_( int r );

    /// Print the state stack on the debug stream.
    virtual void
    yystack_print_();

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol type, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void
    yy_print_( std::ostream&             yyo,
               const basic_symbol<Base>& yysym ) const;

#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void
    yy_destroy_( const char*         yymsg,
                 basic_symbol<Base>& yysym ) const;

private:
    /// Type access provider for state based symbols.
    struct by_state
    {
        /// Default constructor.
        by_state () YY_NOEXCEPT;

        /// The symbol type as needed by the constructor.
        typedef state_type kind_type;

        /// Constructor.
        by_state ( kind_type s ) YY_NOEXCEPT;

        /// Copy constructor.
        by_state ( const by_state& that ) YY_NOEXCEPT;

        /// Record that this symbol is empty.
        void
        clear() YY_NOEXCEPT;

        /// Steal the symbol type from \a that.
        void
        move( by_state& that );

        /// The (internal) type number (corresponding to \a state).
        /// \a empty_symbol when empty.
        symbol_number_type
        type_get() const YY_NOEXCEPT;

        /// The state number used to denote an empty symbol.
        /// We use the initial state, as it does not have a value.
        enum { empty_state = 0 };

        /// The state.
        /// \a empty when empty.
        state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
        /// Superclass.
        typedef basic_symbol<by_state> super_type;
        /// Construct an empty symbol.
        stack_symbol_type ();
        /// Move or copy construction.
        stack_symbol_type ( YY_RVREF ( stack_symbol_type )that );
        /// Steal the contents from \a sym to build this.
        stack_symbol_type ( state_type                 s,
                            YY_MOVE_REF ( symbol_type )sym );
#if YY_CPLUSPLUS < 201103L
        /// Assignment, needed by push_back by some old implementations.
        /// Moves the contents of that.
        stack_symbol_type&
        operator=( stack_symbol_type& that );

        /// Assignment, needed by push_back by other implementations.
        /// Needed by some other old implementations.
        stack_symbol_type&
        operator=( const stack_symbol_type& that );

#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
public:
        // Hide our reversed order.
        typedef typename S::reverse_iterator       iterator;
        typedef typename S::const_reverse_iterator const_iterator;
        typedef typename S::size_type              size_type;
        typedef typename std::ptrdiff_t            index_type;

        stack ( size_type n = 200 )
            : seq_( n )
        {
        }

        /// Random access.
        ///
        /// Index 0 returns the topmost element.
        const T&
        operator[]( index_type i ) const
        {
            return seq_[ size_type( size() - 1 - i ) ];
        }

        /// Random access.
        ///
        /// Index 0 returns the topmost element.
        T&
        operator[]( index_type i )
        {
            return seq_[ size_type( size() - 1 - i ) ];
        }

        /// Steal the contents of \a t.
        ///
        /// Close to move-semantics.
        void
        push( YY_MOVE_REF ( T )t )
        {
            seq_.push_back( T() );
            operator[]( 0 ).move( t );
        }

        /// Pop elements from the stack.
        void
        pop( std::ptrdiff_t n = 1 ) YY_NOEXCEPT
        {
            for (; 0 < n; --n )
            {
                seq_.pop_back();
            }
        }

        /// Pop all elements from the stack.
        void
        clear() YY_NOEXCEPT
        {
            seq_.clear();
        }

        /// Number of elements on the stack.
        index_type
        size() const YY_NOEXCEPT
        {
            return index_type( seq_.size() );
        }

        std::ptrdiff_t
        ssize() const YY_NOEXCEPT
        {
            return std::ptrdiff_t( size() );
        }

        /// Iterator on top of the stack (going downwards).
        const_iterator
        begin() const YY_NOEXCEPT
        {
            return seq_.rbegin();
        }

        /// Bottom of the stack.
        const_iterator
        end() const YY_NOEXCEPT
        {
            return seq_.rend();
        }

        /// Present a slice of the top of a stack.
        class slice
        {
public:
            slice ( const stack& stack, index_type range )
                : stack_( stack )
                , range_( range )
            {
            }

            const T&
            operator[]( index_type i ) const
            {
                return stack_[ range_ - i ];
            }

private:
            const stack& stack_;
            index_type   range_;
        };

private:
        stack ( const stack& );
        stack&
        operator=( const stack& );

        /// The wrapped container.
        S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_( const char* m, YY_MOVE_REF( stack_symbol_type ) sym );

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_( const char* m, state_type s, YY_MOVE_REF( symbol_type ) sym );

    /// Pop \a n symbols from the stack.
    void
    yypop_( int n = 1 );

    /// Some specific tokens.
    static const token_number_type yy_error_token_ = 1;
    static const token_number_type yy_undef_token_ = 2;

    /// Constants.
    enum
    {
        yyeof_     = 0,
        yylast_    = 505, ///< Last index in yytable_.
        yynnts_    = 88,  ///< Number of nonterminal symbols.
        yyfinal_   = 75,  ///< Termination state number.
        yyntokens_ = 92   ///< Number of tokens.
    };


    // User arguments.
    class CubePL1ParseContext& parseContext;
    class CubePL1Scanner&      CubePL1Lexer;
};
} // cubeplparser
#line 888 "../../cubelib/build-frontend/../src/cube/src/syntax/cubepl/CubePL1Parser.hpp"





#endif // !YY_CUBEPLPARSER_CUBELIB_BUILD_FRONTEND_SRC_CUBE_SRC_SYNTAX_CUBEPL_CUBEPL1PARSER_HPP_INCLUDED
